### Instructions for using fad
#### More information available at https://github.com/somakd/fad

## Install package from github using R devtools package
require("devtools")
devtools::install_github("somakd/fad")
### Note for MAC users:
### When asked: "Do you want to install from sources the package which needs compilation? 
###       Answer: Yes

## Load library
library(fad)

## Simple exploratory factor analysis example using fad
?fad
### Generate an n by p data matrix
set.seed(1)
n <- 100 # number of observations
p <- 500 # data dimension
q <- 3 # true number of factors
mu = rnorm(p) 
L = matrix(rnorm(p*q),p,q)
D = runif(p,0.2,0.8)
X = matrix(rnorm(n*q),n,q)
X = tcrossprod(X,L) + matrix(rnorm(n*p),n,p)%*%diag(sqrt(D)) + rep(mu, each = n)

### Determine the number of factors
BICs = rep(NA,11) # store BIC values
for(i in 1:11){
  out = fad(x = X,factors = i-1)
  BICs[i] = out$BIC
}
which.min(BICs)-1 # obtain the optimal factor favored by BIC

